added test script and fixed line endings

This commit is contained in:
Alan Weinstock 2022-03-22 12:04:28 -07:00
parent d4f710f9f5
commit e9fa75cefc
2 changed files with 258 additions and 226 deletions

View file

@ -1,227 +1,227 @@
#!/bin/bash #!/bin/bash
# pyr0ball script functions library # pyr0ball script functions library
# Initial Vars # Initial Vars
scriptname=${0##*/} scriptname=${0##*/}
rundir=${0%/*} rundir=${0%/*}
runuser=$(whoami) runuser=$(whoami)
# Utilities (Setting up colors and bounding boxes) # Utilities (Setting up colors and bounding boxes)
if [[ "$TERM" != "linux" ]] ; then if [[ "$TERM" != "linux" ]] ; then
red=$(echo -e "\033[38;5;1m") # red red=$(echo -e "\033[38;5;1m") # red
grn=$(echo -e "\033[38;5;2m") # green grn=$(echo -e "\033[38;5;2m") # green
ylw=$(echo -e "\033[38;5;3m") # yellow ylw=$(echo -e "\033[38;5;3m") # yellow
blu=$(echo -e "\033[38;5;27m") # blue blu=$(echo -e "\033[38;5;27m") # blue
lbl=$(echo -e "\033[38;5;69m") # light blue lbl=$(echo -e "\033[38;5;69m") # light blue
mag=$(echo -e "\033[38;5;5m") # magenta mag=$(echo -e "\033[38;5;5m") # magenta
cyn=$(echo -e "\033[38;5;6m") # cyan cyn=$(echo -e "\033[38;5;6m") # cyan
pur=$(echo -e "\033[38;5;135m") # purple pur=$(echo -e "\033[38;5;135m") # purple
ong=$(echo -e "\033[38;5;166m") # orange ong=$(echo -e "\033[38;5;166m") # orange
lyl=$(echo -e "\033[38;5;228m") # light yellow lyl=$(echo -e "\033[38;5;228m") # light yellow
lrd=$(echo -e "\033[38;5;196m") # light red lrd=$(echo -e "\033[38;5;196m") # light red
norm=$(echo -e "\033[38;5;9m") # default/normal norm=$(echo -e "\033[38;5;9m") # default/normal
# #
bld=$(echo -e "\033[1m") # bold bld=$(echo -e "\033[1m") # bold
unl=$(echo -e "\033[4m") # underline unl=$(echo -e "\033[4m") # underline
blk=$(echo -e "\033[7m") # blinking not supported in our xterm, so reverse instead blk=$(echo -e "\033[7m") # blinking not supported in our xterm, so reverse instead
nln=$(echo -e "\033[24") nln=$(echo -e "\033[24")
dfl=$(echo -e "\e[0m") dfl=$(echo -e "\e[0m")
fi fi
# For drawing pretty boxes # For drawing pretty boxes
terminal_width=$(tput cols) terminal_width=$(tput cols)
if [ $terminal_width -le 81 ] ; then if [ $terminal_width -le 81 ] ; then
BOXWIDTH=$((terminal_width - 1)) BOXWIDTH=$((terminal_width - 1))
else else
BOXWIDTH=80 BOXWIDTH=80
fi fi
top_border=$(echo -e '\u2501') top_border=$(echo -e '\u2501')
left_border=$(echo -e '\u2503') left_border=$(echo -e '\u2503')
right_border=$(echo -e '\u2503') right_border=$(echo -e '\u2503')
left_top_border=$(echo -e '\u250f') left_top_border=$(echo -e '\u250f')
right_top_border=$(echo -e '\u2513') right_top_border=$(echo -e '\u2513')
left_bottom_border=$(echo -e '\u2517') left_bottom_border=$(echo -e '\u2517')
right_bottom_border=$(echo -e '\u251b') right_bottom_border=$(echo -e '\u251b')
repchar() { repchar() {
n=1 n=1
while [ $n -le $2 ] ; do while [ $n -le $2 ] ; do
echo -n "$1" echo -n "$1"
n=$((n+1)) n=$((n+1))
done done
} }
boxtop() { boxtop() {
echo -n "$left_top_border" echo -n "$left_top_border"
repchar "$top_border" $((BOXWIDTH-1)) repchar "$top_border" $((BOXWIDTH-1))
echo -n "$right_top_border" echo -n "$right_top_border"
echo echo
} }
boxbottom() { boxbottom() {
echo -n "$left_bottom_border" echo -n "$left_bottom_border"
repchar "$top_border" $((BOXWIDTH-1)) repchar "$top_border" $((BOXWIDTH-1))
echo -n "$right_bottom_border" echo -n "$right_bottom_border"
echo echo
} }
boxline() { boxline() {
echo -e "$left_border $1\r\033[${BOXWIDTH}C$right_border" echo -e "$left_border $1\r\033[${BOXWIDTH}C$right_border"
} }
boxseparator(){ boxseparator(){
echo -n "$left_border" echo -n "$left_border"
repchar "-" $((BOXWIDTH-1)) repchar "-" $((BOXWIDTH-1))
echo -n "$right_border" echo -n "$right_border"
echo echo
} }
success(){ success(){
echo -e "\n" echo -e "\n"
boxtop boxtop
boxline " ${scriptname} ${grn}SUCCESS${dfl}$@" boxline " ${scriptname} ${grn}SUCCESS${dfl}$@"
boxbottom boxbottom
exit 0 exit 0
} }
warn(){ warn(){
echo -e "\n" echo -e "\n"
ec=$? ec=$?
boxtop boxtop
boxline "${lrd}WARNING${lyl}[${ong}code=${red}$ec${lyl}]: $@${dfl}" boxline "${lrd}WARNING${lyl}[${ong}code=${red}$ec${lyl}]: $@${dfl}"
boxbottom boxbottom
} }
fail(){ fail(){
ec=$? ec=$?
echo -e "\n" echo -e "\n"
boxtop boxtop
boxline "${lrd}FAILED${lyl}[${ong}code=${red}$ec${lyl}]: $@${dfl}" boxline "${lrd}FAILED${lyl}[${ong}code=${red}$ec${lyl}]: $@${dfl}"
boxbottom boxbottom
exit $ec exit $ec
} }
pushd(){ pushd(){
command pushd "$@" > /dev/null command pushd "$@" > /dev/null
} }
popd(){ popd(){
command popd "$@" > /dev/null command popd "$@" > /dev/null
} }
popdfail(){ popdfail(){
ec=$? ec=$?
popd popd
$(exit $ec) #restore the exit code $(exit $ec) #restore the exit code
fail "$@" fail "$@"
} }
logger(){ logger(){
#$@ 2>&1 | tee >(ts "[$scriptname][%d-%m-%y %H_%M_%S]" > $logfile) # This version of prepend requires the 'ts' utility from 'moreutils' package #$@ 2>&1 | tee >(ts "[$scriptname][%d-%m-%y %H_%M_%S]" > $logfile) # This version of prepend requires the 'ts' utility from 'moreutils' package
$@ 2>&1 | tee >(while IFS= read -r line; do printf '[%s] %s\n' "${scriptname}][$(date '+%Y-%m-%d %H:%M:%S')" "$line"; done >> $logfile) $@ 2>&1 | tee >(while IFS= read -r line; do printf '[%s] %s\n' "${scriptname}][$(date '+%Y-%m-%d %H:%M:%S')" "$line"; done >> $logfile)
} }
ctrl_c(){ ctrl_c(){
echo -e "\n" echo -e "\n"
fail "User interrupted with Ctrl-C" fail "User interrupted with Ctrl-C"
} }
# ensure ctrl-c to cancel script ends the entire process and not just the current function # ensure ctrl-c to cancel script ends the entire process and not just the current function
trap ctrl_c INT trap ctrl_c INT
# Renders a text based list of options that can be selected by the # Renders a text based list of options that can be selected by the
# user using up, down and enter keys and returns the chosen option. # user using up, down and enter keys and returns the chosen option.
# #
# Arguments : list of options, maximum of 256 # Arguments : list of options, maximum of 256
# "opt1" "opt2" ... # "opt1" "opt2" ...
# Return value: selected index (0 for opt1, 1 for opt2 ...) # Return value: selected index (0 for opt1, 1 for opt2 ...)
select_option(){ select_option(){
# little helpers for terminal print control and key input # little helpers for terminal print control and key input
ESC=$( printf "\033") ESC=$( printf "\033")
cursor_blink_on() { printf "$ESC[?25h"; } cursor_blink_on() { printf "$ESC[?25h"; }
cursor_blink_off() { printf "$ESC[?25l"; } cursor_blink_off() { printf "$ESC[?25l"; }
cursor_to() { printf "$ESC[$1;${2:-1}H"; } cursor_to() { printf "$ESC[$1;${2:-1}H"; }
print_option() { printf " $1 "; } print_option() { printf " $1 "; }
print_selected() { printf " $ESC[7m $1 $ESC[27m"; } print_selected() { printf " $ESC[7m $1 $ESC[27m"; }
get_cursor_row() { IFS=';' read -sdR -p $'\E[6n' ROW COL; echo ${ROW#*[}; } get_cursor_row() { IFS=';' read -sdR -p $'\E[6n' ROW COL; echo ${ROW#*[}; }
key_input() { read -s -n3 key 2>/dev/null >&2 key_input() { read -s -n3 key 2>/dev/null >&2
if [[ $key = $ESC[A ]]; then echo up; fi if [[ $key = $ESC[A ]]; then echo up; fi
if [[ $key = $ESC[B ]]; then echo down; fi if [[ $key = $ESC[B ]]; then echo down; fi
if [[ $key = "" ]]; then echo enter; fi; } if [[ $key = "" ]]; then echo enter; fi; }
# initially print empty new lines (scroll down if at bottom of screen) # initially print empty new lines (scroll down if at bottom of screen)
for opt; do printf "\n"; done for opt; do printf "\n"; done
# determine current screen position for overwriting the options # determine current screen position for overwriting the options
local lastrow=`get_cursor_row` local lastrow=`get_cursor_row`
local startrow=$(($lastrow - $#)) local startrow=$(($lastrow - $#))
# ensure cursor and input echoing back on upon a ctrl+c during read -s # ensure cursor and input echoing back on upon a ctrl+c during read -s
trap "cursor_blink_on; stty echo; printf '\n'; exit" 2 trap "cursor_blink_on; stty echo; printf '\n'; exit" 2
cursor_blink_off cursor_blink_off
local selected=0 local selected=0
while true; do while true; do
# print options by overwriting the last lines # print options by overwriting the last lines
local idx=0 local idx=0
for opt; do for opt; do
cursor_to $(($startrow + $idx)) cursor_to $(($startrow + $idx))
if [ $idx -eq $selected ]; then if [ $idx -eq $selected ]; then
print_selected "$opt" print_selected "$opt"
else else
print_option "$opt" print_option "$opt"
fi fi
((idx++)) ((idx++))
done done
# user key control # user key control
case `key_input` in case `key_input` in
enter) break;; enter) break;;
up) ((selected--)); up) ((selected--));
if [ $selected -lt 0 ]; then selected=$(($# - 1)); fi;; if [ $selected -lt 0 ]; then selected=$(($# - 1)); fi;;
down) ((selected++)); down) ((selected++));
if [ $selected -ge $# ]; then selected=0; fi;; if [ $selected -ge $# ]; then selected=0; fi;;
esac esac
done done
# cursor position back to normal # cursor position back to normal
cursor_to $lastrow cursor_to $lastrow
printf "\n" printf "\n"
cursor_blink_on cursor_blink_on
return $selected return $selected
} }
# Example for above select_option # Example for above select_option
#echo "Select one option using up/down keys and enter to confirm:" #echo "Select one option using up/down keys and enter to confirm:"
#echo #echo
#options=("one" "two" "three") #options=("one" "two" "three")
#select_option "${options[@]}" #select_option "${options[@]}"
#choice=$? #choice=$?
#echo "Choosen index = $choice" #echo "Choosen index = $choice"
#echo " value = ${options[$choice]}" #echo " value = ${options[$choice]}"
select_opt(){ select_opt(){
select_option "$@" 1>&2 select_option "$@" 1>&2
local result=$? local result=$?
echo $result echo $result
return $result return $result
} }
# Examples for above select_opt # Examples for above select_opt
#case `select_opt "Yes" "No" "Cancel"` in #case `select_opt "Yes" "No" "Cancel"` in
# 0) echo "selected Yes";; # 0) echo "selected Yes";;
# 1) echo "selected No";; # 1) echo "selected No";;
# 2) echo "selected Cancel";; # 2) echo "selected Cancel";;
#esac #esac
#options=("Yes" "No" "${array[@]}") # join arrays to add some variable array #options=("Yes" "No" "${array[@]}") # join arrays to add some variable array
#case `select_opt "${options[@]}"` in #case `select_opt "${options[@]}"` in
# 0) echo "selected Yes";; # 0) echo "selected Yes";;
# 1) echo "selected No";; # 1) echo "selected No";;
# *) echo "selected ${options[$?]}";; # *) echo "selected ${options[$?]}";;
#esac #esac

View file

@ -0,0 +1,32 @@
#!/bin/bash
scriptname=${0##*/}
rundir=${0%/*}
runuser=$(whoami)
source ${rundir}/functions
# Example for above select_option
echo "Select one option using up/down keys and enter to confirm:"
echo
options=("one" "two" "three")
select_option "${options[@]}"
choice=$?
echo "Choosen index = $choice"
echo " value = ${options[$choice]}"
# Examples for above select_opt
case `select_opt "Yes" "No" "Cancel"` in
0) echo "selected Yes";;
1) echo "selected No";;
2) echo "selected Cancel";;
esac
#options=("Yes" "No" "${array[@]}") # join arrays to add some variable array
case `select_opt "${options[@]}"` in
0) echo "selected Yes";;
1) echo "selected No";;
*) echo "selected ${options[$?]}";;
esac